var express     = require("express");
var assert      = require('assert');
var bodyParser = require('body-parser')
var find_some   = require('./crud_mongo/find_some.js');
var delete_id   = require('./crud_mongo/delete.js');
var find_one    = require('./crud_mongo/find_one.js');
var updateRestaurants = require("./crud_mongo/update.js");
var insertDocument = require('./crud_mongo/insert_document.js');
var MongoClient = require('mongodb').MongoClient;
var ObjectId    = require('mongodb').ObjectID;
var url         = 'mongodb://localhost:27017/test';

var app = express();
app.use(express.static('./public'));
app.use( bodyParser.json() ); 
app.use(bodyParser.urlencoded({ extended: true }));
var docReturn = [];

//test de la connexion avec mongodb
MongoClient.connect(url, function(err, db) {
  assert.equal(null, err);
  console.log("Connected correctly to server", url);
  db.close();
});



app.get('/', function (req, res) {
    console.log("test d'index");
  res.sendFile("index.html");

});
app.get('/test', function (req, res) {
    console.log("test de mongo db");
    res.end("MongoDB connexion effectuée");
});

app.get('/findSome', function (req, res) {
	MongoClient.connect(url, function(err, db) {
	  assert.equal(null, err);
	  find_some.findRestaurants(db, function(docReturn) {
		  db.close();
		  res.end(JSON.stringify(docReturn));

	  });
	});
});

app.delete('/deleteRow/:id', function (req, res) {
	MongoClient.connect(url, function(err, db) {
	  assert.equal(null, err);
	  delete_id.removeRestaurants(db,new ObjectId(req.params.id), function() {
		  db.close();
		  res.end();
	  });
	});
});
app.get('/getDocument/:id', function (req, res) {
    console.log(req.params.id);
	MongoClient.connect(url, function(err, db) {
	  assert.equal(null, err);
	  find_one.findRestaurants(db,new ObjectId(req.params.id), function(docReturn) {
		  db.close();
		  res.end(JSON.stringify(docReturn));
	  });
	});
});

app.post('/updateRow', function (req, res) {
    
    var longitude = Math.floor((Math.random() * 360)-180);
    var latitude = Math.floor((Math.random() * 360)-180)
   
    console.log(req.body); 

    console.log("PARAMS"); 
    req.body.restaurant_id  = new Date().getTime();
    req.body.grades.date    = new Date();
    req.body.address.coord  = [longitude,latitude];
    console.log(req.body.id);
    var grade = req.body.grades;
    req.body.grades = [];
    req.body.grades.push({"date":grade.date,"grade":grade.grade,"score":Number(grade.score)});
    
	MongoClient.connect(url, function(err, db) {
	  assert.equal(null, err);
	  updateRestaurants.updateRestaurants(db,req.body,new ObjectId(req.body.id), function() {
		  db.close();
		  res.end("Document ajouté!");
	  });
	});
});
app.post('/insert', function (req, res) {
    var longitude = Math.floor((Math.random() * 360)-180);
    var latitude = Math.floor((Math.random() * 360)-180)
    console.log("PARAMS"); 
    req.body.restaurant_id  = new Date().getTime();
    req.body.grades.date    = new Date();
    req.body.address.coord  = [longitude,latitude];
    var grade = req.body.grades;
    req.body.grades = [];
    req.body.grades.push({"date":grade.date,"grade":grade.grade,"score":Number(grade.score)});
    console.log(req.body);

	MongoClient.connect(url, function(err, db) {
	  assert.equal(null, err);
	  insertDocument.insertDocument(db,req.body, function() {
		  db.close();
		  res.end("Document ajouté!");
	  });
	});
});



app.listen(3000, function () {
    console.log("Server is listening on port 3000");
});